/*****************************************************
This program was produced by the
CodeWizardAVR V2.05.0 Professional
Automatic Program Generator
 Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 11.03.2012
Author  : 
Company : 
Comments: 


Chip type               : ATmega8
Program type            : Application
AVR Core Clock frequency: 8,000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 256
*****************************************************/

#include <mega8.h>
#include <delay.h>

#define OPEN PORTD.4=0; PORTD.5=1; PORTB.1=1;
#define CLOSE PORTD.4=1; PORTD.5=0; PORTB.1=1;
#define STOP PORTD.4=0; PORTD.5=0; PORTB.1=0;


#ifndef RXB8
#define RXB8 1
#endif

#ifndef TXB8
#define TXB8 0
#endif

#ifndef UPE
#define UPE 2
#endif

#ifndef DOR
#define DOR 3
#endif

#ifndef FE
#define FE 4
#endif

#ifndef UDRE
#define UDRE 5
#endif

#ifndef RXC
#define RXC 7
#endif

#define FRAMING_ERROR (1<<FE)
#define PARITY_ERROR (1<<UPE)
#define DATA_OVERRUN (1<<DOR)
#define DATA_REGISTER_EMPTY (1<<UDRE)
#define RX_COMPLETE (1<<RXC)

// USART Receiver buffer
#define RX_BUFFER_SIZE 8
char rx_buffer[RX_BUFFER_SIZE];

#if RX_BUFFER_SIZE <= 256
unsigned char rx_wr_index,rx_rd_index,rx_counter;
#else
unsigned int rx_wr_index,rx_rd_index,rx_counter;
#endif

// This flag is set on USART Receiver buffer overflow
bit rx_buffer_overflow;

// USART Receiver interrupt service routine
interrupt [USART_RXC] void usart_rx_isr(void)
{
char status,data;
status=UCSRA;
data=UDR;
if ((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0)
   {
   rx_buffer[rx_wr_index++]=data;
#if RX_BUFFER_SIZE == 256
   // special case for receiver buffer size=256
   if (++rx_counter == 0)
      {
#else
   if (rx_wr_index == RX_BUFFER_SIZE) rx_wr_index=0;
   if (++rx_counter == RX_BUFFER_SIZE)
      {
      rx_counter=0;
#endif
      rx_buffer_overflow=1;
      }
   }
}

#ifndef _DEBUG_TERMINAL_IO_
// Get a character from the USART Receiver buffer
#define _ALTERNATE_GETCHAR_
#pragma used+
char getchar(void)
{
char data;
while (rx_counter==0);
data=rx_buffer[rx_rd_index++];
#if RX_BUFFER_SIZE != 256
if (rx_rd_index == RX_BUFFER_SIZE) rx_rd_index=0;
#endif
#asm("cli")
--rx_counter;
#asm("sei")
return data;
}
#pragma used-
#endif

// USART Transmitter buffer
#define TX_BUFFER_SIZE 8
char tx_buffer[TX_BUFFER_SIZE];

#if TX_BUFFER_SIZE <= 256
unsigned char tx_wr_index,tx_rd_index,tx_counter;
#else
unsigned int tx_wr_index,tx_rd_index,tx_counter;
#endif

// USART Transmitter interrupt service routine
interrupt [USART_TXC] void usart_tx_isr(void)
{
if (tx_counter)
   {
   --tx_counter;
   UDR=tx_buffer[tx_rd_index++];
#if TX_BUFFER_SIZE != 256
   if (tx_rd_index == TX_BUFFER_SIZE) tx_rd_index=0;
#endif
   }
}

#ifndef _DEBUG_TERMINAL_IO_
// Write a character to the USART Transmitter buffer
#define _ALTERNATE_PUTCHAR_
#pragma used+
void putchar(char c)
{
while (tx_counter == TX_BUFFER_SIZE);
#asm("cli")
if (tx_counter || ((UCSRA & DATA_REGISTER_EMPTY)==0))
   {
   tx_buffer[tx_wr_index++]=c;
#if TX_BUFFER_SIZE != 256
   if (tx_wr_index == TX_BUFFER_SIZE) tx_wr_index=0;
#endif
   ++tx_counter;
   }
else
   UDR=c;
#asm("sei")
}
#pragma used-
#endif

// Standard Input/Output functions
#include <stdio.h>

#define S_TIK_MIN 0x06
#define S_TIK_MAX 0x0A

#define L_TIK_MIN 0x0C
#define L_TIK_MAX 0x12
unsigned char tik;
unsigned char ready; // 1 -  , 0 -  
unsigned char count; //   
unsigned char sinc; //1 -   , 0 -  
unsigned char len;  //0 -  , 1 -  
unsigned char nibl[11]; // 
unsigned char code[6]; // 
unsigned char n_count=0; // 
unsigned char bit_count; // 
unsigned char rcb; // 
unsigned char b_prt; // 
unsigned char n_prt; // 
unsigned char read_ok; // 
eeprom char card[80][5]= {{0x4E, 0x00, 0x99, 0x2A, 0x61}};
//card [0][0]=0x4E; card [0][1]= 0x00; card [0][2]= 0x99; card [0][3]= 0x2A; card [0][4]= 0x61;

//eeprom char card_count;

void flip(void)
{
    if((tik>S_TIK_MIN) && (tik<S_TIK_MAX)){len=0; /*UDR=48;*/}
    else {
       if((tik>L_TIK_MIN)&&(tik<L_TIK_MAX)){len=1;/* UDR=49;*/}
       else{ready=0; /*UDR=0x2A;*/} //  
    }

    if(!ready){
        if(!len){
            if (++count==16){/*UDR=82*/; ready=1;  sinc=1; count=0; bit_count=0; n_count=0; nibl[0]=0; b_prt=0; n_prt=0;}
        }    
        else{count=0; sinc=0;}
    }
    else{
        if(len){                  
            if(sinc){count++;}       //    sinc=1     -
            else{ready=0; read_ok=0;/* UDR=83;*/}   // 
        } 
        else{
            if(sinc){sinc=0;}         //    sinc=1    
            else{sinc=1; count++;}    //  
        } 
        if(ready&&sinc){              //   
            if(++bit_count!=5){       //    ,       
                b_prt^=rcb; 
                nibl[n_count]=nibl[n_count]<<1|rcb;
            }    
            else{ 
                if((b_prt!=rcb)&&(n_count<10)){ready=0;read_ok=0;/*UDR=112;*/}
                else{
                    if(++n_count==11){  //   , 10- 
                        if(nibl[n_count-1]==n_prt){ //   
                            ready=0; 
                            read_ok++;
                            n_count=0;
                            for (count=0;count<5;count++) {
                                code[count]=0;    
                                code[count]=code[count]|(nibl[n_count++]<<4);
                                code[count]=code[count]|nibl[n_count++];      
                            }
                            code[5]=0;
                        } 
                        else{ready=0; read_ok=0;/* UDR=80;*/}  //     
                    }
                    else{n_prt^=nibl[n_count-1];b_prt=0; bit_count=0; nibl[n_count]=0;} //  
                }
            }
        } 
    }  
}

char n;  // 
char rb; // 
char l;  // 
char tk; // 
char rd; // -  
char key; //
char key_press;
interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{
// Reinitialize Timer 0 value
    TCNT0=0xE0;

    if(ACSR&0x20){n=0;}
    else {n=1;}
    if(n!=rb){
        if(++l>3){
            tik=tk;
            //UDR=tik;
            PORTD.2=n;
            rcb=n;
            rb=n;
            tk=l;
            l=0;
            rd=1;
        }         
    }
    else{
        if(l){tk=tk+l; l=0;}
        tk++;
        if(!PINC.5){
            if(++key>50){key_press=1; key=0;}
        }
    }
}

// Declare your global variables here

void main(void)
{
// Declare your local variables here
char t;
char i;
char chek_ok; //   
PORTB=0x00;
DDRB=0b00001010;

PORTC=0xFF;
DDRC=0x00;

PORTD=0x00;
DDRD=0b00111110;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 1000,000 kHz
TCCR0=0x02;
TCNT0=0xE0;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer1 Stopped
// Mode: Normal top=0xFFFF
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: 8000,000 kHz
// Mode: CTC top=OCR2
// OC2 output: Toggle on compare match
ASSR=0x00;
TCCR2=0x19;
TCNT2=0x00;
OCR2=31;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x01;

// USART initialization
// Communication Parameters: 8 Data, 1 Stop, No Parity
// USART Receiver: On
// USART Transmitter: On
// USART Mode: Asynchronous
// USART Baud Rate: 56000
UCSRA=0x00;
UCSRB=0xD8;
UCSRC=0x86;
UBRRH=0x00;
UBRRL=0x08;

// Analog Comparator initialization
// Analog Comparator: On
// The Analog Comparator's positive input is
// connected to the Bandgap Voltage Reference
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x40;
SFIOR=0x00;

// Global enable interrupts
#asm("sei")
putsf("<RFID READER>");
while (1)
      { 
        if (rd){rd=0; flip();};
        if (read_ok){
            t=0;
            read_ok=0;
            while (t!=5) {
                printf(" %02X",  code[t++]);
            }; 
            putsf(" "); 
            t=0; i=0; chek_ok=0; 
            while(!chek_ok){
                if(code[t]==card[i][t]){
                       if(++t==5){chek_ok=1;}
                }
                else{
                    t=0;
                    if(++i==80){chek_ok=2;}
                }
            }
            
            
                  // 
            switch(chek_ok){
                case 1:
                    putsf("Known card");  
                    OPEN
                    delay_ms(270);
                    STOP
                    delay_ms(3000);
                    CLOSE
                    delay_ms(270);
                    STOP
                    delay_ms(3000);
                break;                
                case 2: 
                    if(key_press){
                        key_press=0;
                        i=0;
                        while((card[i][0]!=0xFF)&&(++i!=80));
                        t=0;
                        putchar(i);
                        do{
                        card[i][t]=code[t];   
                        }
                        while(++t!=5);
                        putsf("Card saved");
                        delay_ms(1000);
                    }
                    else{
                    putsf("Unknown card");
                    }
                        

                break;
            }
        } 
      } 
}
